"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const ResultCtaButton_1 = tslib_1.__importDefault(require("../ResultCtaButton/ResultCtaButton"));
function ResultCard(props) {
    var _a, _b, _c;
    const { result, addToCartCallback, clickItemCallback, salePriceKey, regularPriceKey } = props;
    const salePrice = salePriceKey && ((_a = result === null || result === void 0 ? void 0 : result.data) === null || _a === void 0 ? void 0 : _a[salePriceKey]);
    const regularPrice = regularPriceKey && ((_b = result === null || result === void 0 ? void 0 : result.data) === null || _b === void 0 ? void 0 : _b[regularPriceKey]);
    const clickHandler = () => {
        if (clickItemCallback && typeof clickItemCallback === 'function') {
            clickItemCallback(result);
        }
    };
    const keyDownHandler = (event) => {
        if ((event === null || event === void 0 ? void 0 : event.key) === ' ' || (event === null || event === void 0 ? void 0 : event.key) === 'Enter') {
            if (clickItemCallback && typeof clickItemCallback === 'function') {
                clickItemCallback(result);
            }
        }
    };
    const resultCardContent = () => {
        var _a;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("div", { className: 'cio-result-card-image' },
                react_1.default.createElement("img", { src: (_a = result.data) === null || _a === void 0 ? void 0 : _a.image_url, alt: 'product' })),
            react_1.default.createElement("div", { className: 'cio-result-card-text' },
                react_1.default.createElement("p", { className: 'cio-result-card-title' }, result.value),
                react_1.default.createElement("div", { className: 'cio-result-card-prices' },
                    salePrice && react_1.default.createElement("span", { className: 'cio-result-card-sale-price' },
                        "$",
                        salePrice),
                    regularPrice && (react_1.default.createElement("span", { className: `cio-result-card-regular-price${salePrice ? '--strike-through' : ''}` },
                        "$",
                        regularPrice)))),
            react_1.default.createElement(ResultCtaButton_1.default, { item: result, callback: addToCartCallback })));
    };
    if (clickItemCallback) {
        return (react_1.default.createElement("div", { onClick: clickHandler, onKeyDown: keyDownHandler, className: 'cio-result-card', role: 'button', tabIndex: 0 }, resultCardContent()));
    }
    return (react_1.default.createElement("div", { className: 'cio-result-card' },
        react_1.default.createElement("a", { className: 'cio-result-card-anchor', href: (_c = result.data) === null || _c === void 0 ? void 0 : _c.url }, resultCardContent())));
}
exports.default = ResultCard;
