"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const RedoButton_1 = tslib_1.__importDefault(require("../RedoButton/RedoButton"));
const actions_1 = require("../CioQuiz/actions");
const context_1 = tslib_1.__importDefault(require("../CioQuiz/context"));
const ResultFilters_1 = tslib_1.__importDefault(require("../ResultFilters/ResultFilters"));
const ZeroResults_1 = tslib_1.__importDefault(require("../ZeroResults/ZeroResults"));
const Results_1 = tslib_1.__importDefault(require("../Results/Results"));
function ResultContainer(props) {
    var _a, _b, _c;
    const { options, resetQuizSessionId } = props;
    const { addToCartCallback, clickItemCallback, resultCardSalePriceKey, resultCardRegularPriceKey, } = options;
    const { resultsResponse } = (0, react_1.useContext)(context_1.default);
    const { dispatch } = (0, react_1.useContext)(context_1.default);
    const filterExpression = (_a = resultsResponse === null || resultsResponse === void 0 ? void 0 : resultsResponse.request) === null || _a === void 0 ? void 0 : _a.collection_filter_expression;
    const zeroResults = !((_c = (_b = resultsResponse === null || resultsResponse === void 0 ? void 0 : resultsResponse.response) === null || _b === void 0 ? void 0 : _b.results) === null || _c === void 0 ? void 0 : _c.length);
    const resultsTitle = zeroResults ? 'Oops, there are no results' : 'Here are your results';
    const onResetClick = () => {
        if (dispatch && resultsResponse) {
            resetQuizSessionId();
            dispatch({
                type: actions_1.QuestionTypes.Reset,
            });
        }
    };
    if (resultsResponse) {
        return (react_1.default.createElement("div", { className: 'cio-results-container' },
            react_1.default.createElement("h1", { className: 'cio-results-title' }, resultsTitle),
            react_1.default.createElement("div", { className: 'cio-results-filter-and-redo-container' },
                react_1.default.createElement(ResultFilters_1.default, { filters: filterExpression }),
                react_1.default.createElement(RedoButton_1.default, { onClick: onResetClick })),
            !zeroResults && (react_1.default.createElement(Results_1.default, { addToCartCallback: addToCartCallback, clickItemCallback: clickItemCallback, resultCardSalePriceKey: resultCardSalePriceKey, resultCardRegularPriceKey: resultCardRegularPriceKey })),
            zeroResults && react_1.default.createElement(ZeroResults_1.default, null)));
    }
    return react_1.default.createElement("div", null, "Loading");
}
exports.default = ResultContainer;
